/*     
    plaquette chain   v0.2 (c) JS 2001(v0.1)-2007
       
	      1   4
	   \ / \ / \ /
	    0   3   6
	   / \ / \ / \
	      2   5
*/
#include <stdlib.h>
#include <stdio.h>

int initvars(int n0,int pbc){
   int i,nn,nw;
   nn=((pbc==1)?3*n0:3*n0+1);
   nw=((pbc==1)?5*n0:5*n0+0);
   printf("# def-file, dimer-plaquette\n"
	"# automaticly generated by m_p v0.1 n0=%d J1=Jp J2=Jf PBC=%d\n"
	"#===edge=== %d 0 0 99\n"
	"#+++model+++\n"
	"# NN=Number_of_sites Nw=Number_of_bonds Nv=Number_of_bonds(2)\n"
	"%d %d 0\n"
	"# s  X  Y  Z e# U# (s=siteindex  (X Y Z)=position eU=parameter-idx)\n",
     n0,pbc,n0*2,nn,nw);
   for(i=0;i<n0;i++)
   printf(" %2d %2d %2d 0 e8 u7\n"
          " %2d %2d %2d 0 e8 u7\n"
          " %2d %2d %2d 0 e8 u7\n",
          3*i+0,2*i+0,1,
          3*i+1,2*i+1,2,
          3*i+2,2*i+1,0);
   if(pbc==0) printf(" %2d %2d %2d 0 e8 u7\n",3*n0+0,2*n0+0,1);
   printf("# Bond s1 s2 t# J# V# w#\n");
   for(i=0;i<n0;i++){
     printf(" %2d %2d %2d t0  j2 v0 w3\n"
            " %2d %2d %2d t0  j1 v0 w4\n"
            " %2d %2d %2d t0  j1 v0 w5\n"
            " %2d %2d %2d t0 %cj1 v0 w5\n"
            " %2d %2d %2d t0 %cj1 v0 w4\n",
            5*i+0,i*3+1,i*3+2,	/* frustration */
            5*i+1,i*3+0,i*3+1,	/* plaquette */
            5*i+2,i*3+0,i*3+2,
            5*i+3,i*3+1,(i*3+3)%nn,((i+1==n0 && pbc==1)?'+':' '),
            5*i+4,i*3+2,(i*3+3)%nn,((i+1==n0 && pbc==1)?'+':' '));
   }
   printf("#---model---\n");
    return 0;}


main(int argc,char *argv[]){
   if(argc!=3){
     fprintf(stderr,
       " generate daten.def for plaquette chain v0.2 JS07\n"
       " use: m_p ?length? ?PBC?\n"
       "   length: 1..6  chain length divided by 3\n"
       "   PBC:    0/1   open/periodic boundary conditions\n");
     exit(1);
   }
   initvars(atoi(argv[1]),atoi(argv[2]));
}
