
    
/* --- --- calculation of smallest eigenvalues using Lanczos (Gagliano) ---- */
/* --- Inp: iv  Out: v0,itr,ew  Wrk: v1 */
int lanz1(scplx *v0,scplx *v1,scplx *ev,thbuf *hbuf[B_NUM]);
      
/* ----------- bisection methode -------------------------------------
 * --- Inp: ta,tb=Tridiagonalmatrix(TM),  nn=dimension der matrix  ---
 * ---      ne=number of lowest eigenvalues ew, ep=accuracy       ---
 * --- Out: ew  eigenvalues of the TM via Null-points of Det(A-x*I) --- */
/* --- ToDo: what happens with degeneracy? => EW only once!? --- */
/* void bisec(int nn,int ne,double ep); */

/* --- EVs of a tridiagonal matrix using invers iteration */
/* --- nn matrixsize, {ta,tb} TriDiagMatrix, ne0 - offset -> tc EVs */
/* --- degeneracy is given in ew[] (ex: ew[1]-ew[0]<=1e-10) */
/* void vec12(int nn,int nev, int ne0); */

/* int konvergenz(double *ew,double *et,double eps);*/ 	/* from inc1() */

/* --- --- Calculation of smallest eigenvalues EW via Lanczos --------------------- */
/* --- Inp: iv  Out: a,b,itr,ew  Wrk: v0,v1 ret: iterations */
int inc1(int nev,int ne0,scplx *v0,scplx *v1,thbuf *hbuf[B_NUM]);
    
/* --- eigenvector by the Lanczos method 
 * --- Inp: a,b,c --- Out: v0,v1,ev */
void incv1(int nev,scplx *v0,scplx *v1,scplx *ev[],int itr,thbuf *hbuf[B_NUM]);

/* --- calculation of smallest eigenvaue EW using special-Lanczos 2x2 matrix
 * --- Inp: iv,v0=startvektor  Out: itr,ew,v0=eigenvektor  ---------- */
int lanz2(scplx *v0, thbuf *hbuf[B_NUM]); /* return number of iterations done */
    
/* ----------------- Diag using Jacobi (slow) --------------------------- */
void jacobi2(double a[], int n, double d[], double v[]);
